#include <stdio.h>

#include "expr.h"

Expr* plus(Expr *e1, Expr* e2)
{
  ALLOCATE(Plus, r);
  r->e1 = e1;
  r->e2 = e2;
  return &r->base;
}

void Plus_print(...)
{
  ...
  print(this->e1, f);
  fprintf(f, " + ");
  print(this->e2, f);
}

int Plus_precedence(...)
{
  return PREC_TERM;
}

double Plus_eval(...)
{
  ...
  return eval(this->e1)+eval(this->e2);
}

int main()
{
  Expr *p = plus(number(2), times(number(4), over(number(10), number(3))));
  print(p, stdout);
  printf(" => %g\n", eval(p));
}
